<!--
 Copyright © VNG Realisatie 2024
 Licensed under the EUPL
-->

{{ define "content" }}
    <script>
        document.body.addEventListener("htmx:beforeSwap", function (evt) {
            if (
                evt.detail.xhr.status === 400 ||
                evt.detail.xhr.status === 500
            ) {
                evt.detail.shouldSwap = true;
                evt.detail.isError = false;
            }
        });
    </script>

    <div class="connect-to-service-delegated-page">
        <p>
            <a href="/delegated-connections" class="button--link"
                >{{ svg "icon-chevron-left" "icon--inline" }}
                {{ i18n "Back" }}</a
            >
        </p>

        {{ if ne (len .SuccessMessage) 0 }}
            <div class="alert--success">
                <p class="alert__title">{{ i18n "Success" }}</p>
                <p class="alert__content">{{ .SuccessMessage }}</p>
            </div>
        {{ end }}

        {{ if ne (len .ErrorMessages) 0 }}
            {{ block "errors" . }}
            {{ end }}
        {{ end }}


        <form
            hx-boost="true"
            hx-swap="outerHTML show:window:top"
            action="/services/connection/delegate"
            method="post"
            autocomplete="off"
            class="connect-to-service-delegated-page__form"
            hx-disabled-elt="button[type=submit]"
        >
            <input
                type="hidden"
                name="csrfToken"
                value="{{ .BaseAuthenticatedPage.CsrfToken }}"
            />
            <datalist id="peerIDs">
                {{ range $peerID, $peer := .PeerIDs }}
                    <option value="{{ $peerID }}" label="{{ $peer }}"></option>
                {{ end }}
            </datalist>

            <fieldset class="connect-to-service-delegated-page__form-actions">
                <button type="submit" class="button--primary">
                    {{ i18n "Connect" }}
                </button>
            </fieldset>

            <fieldset>
                <label>
                    <span>{{ i18n "Service Peer ID" }}</span>
                    {{ if .Form.ServiceProviderPeerID }}
                        <input
                            class="input--large"
                            type="text"
                            name="serviceProviderPeerID"
                            value="{{ .Form.ServiceProviderPeerID }}"
                            readonly
                        />
                    {{ else }}
                        <div class="datalist datalist--medium">
                            <input
                                list="peerIDs"
                                name="serviceProviderPeerID"
                                value="{{ .Form.ServiceProviderPeerID }}"
                            />
                        </div>
                    {{ end }}
                </label>

                <label>
                    <span>{{ i18n "Service Name" }}</span>
                    <input
                        class="input--medium"
                        type="text"
                        name="serviceName"
                        value="{{ .Form.ServiceName }}"
                    />
                </label>

                <label>
                    <span>{{ i18n "Service Delegator Peer ID" }}</span>
                    <div class="datalist datalist--medium">
                        <input
                            list="peerIDs"
                            name="serviceDelegatorPeerID"
                            value="{{ .Form.ServiceDelegatorPeerID }}"
                        />
                    </div>
                </label>

                <label>
                    <span>{{ i18n "Outway Peer ID" }}</span>
                    <small
                        >{{ i18n "Peer ID of the Peer who will connect on your behalf." }}</small
                    >
                    <div class="datalist datalist--medium">
                        <input
                            list="peerIDs"
                            name="outwayPeerID"
                            value="{{ .Form.OutwayPeerID }}"
                        />
                    </div>
                </label>

                {{ range $i, $thumbprint := $.Form.OutwayPublicKeyThumbprints }}
                    <label>
                        <span>{{ i18n "Outway Public Key Thumbprint" }}</span>
                        <small
                            >{{ i18n "The thumbprint of the Public Key used by the Outway you want to connect" }}</small
                        >
                        <input
                            class="input--medium"
                            name="outwayPublicKeyThumbprints"
                            type="text"
                            id="outwayPublicKeyThumbprints.{{ $i }}"
                            value="{{ $thumbprint }}"
                            required
                            oninvalid="outwayPublicKeyThumbprintOnInvalidHandler(this)"
                            oninput="this.setCustomValidity('')"
                        />
                    </label>
                {{ end }}


                <button
                    class="button--link"
                    name="action"
                    value="{{ .ActionAddOutwayPublicKeyThumbprint }}"
                >
                    {{ svg "icon-plus"
                        "icon--inline"
                    }}

                    {{ i18n "Add" }}
                </button>

                <div
                    class="connect-to-service-delegated-page__date-field-wrapper"
                >
                    <label
                        class="connect-to-service-delegated-page__date-field"
                    >
                        {{ i18n "Valid from" }}
                        <input
                            class="input--small"
                            type="date"
                            name="validFrom"
                            value="{{ .Form.ValidFrom }}"
                            placeholder="{{ i18n " yyyy-mm-dd" }}"
                        />
                    </label>

                    <label
                        class="connect-to-service-delegated-page__date-field"
                    >
                        {{ i18n "Valid until" }}
                        <input
                            class="input--small"
                            type="date"
                            name="validUntil"
                            value="{{ .Form.ValidUntil }}"
                            placeholder="{{ i18n " yyyy-mm-dd" }}"
                        />
                    </label>
                </div>
            </fieldset>

            <script>
                function outwayPublicKeyThumbprintOnInvalidHandler(el) {
                    if (el.validity.valueMissing) {
                        el.setCustomValidity('{{ i18n "Outway Public Key Thumbprint is required" }}')
                    }
                }
            </script>
        </form>
    </div>
{{ end }}
